// Netscape Windows API Sample program.
// Mostly constructed by Microsoft AppWizard;
// remainder written by Erik DeBenedictis, Scalable Computing.
// Comments to 71553.714@compuserve.com.
// This file accessible via
//	http://www.best.com/~erikd/nswinsample/readme.htm.
// Copyright (c) 1995, Erik P. DeBenedictis;
// cpying and commercial use are allowed if this copyright
// notice is included.
//
#include "stdafx.h"
#include "nswinsam.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CApp

BEGIN_MESSAGE_MAP(CApp, CWinApp)
	//{{AFX_MSG_MAP(CApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CApp construction

CApp::CApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

CApp::~CApp()
{
	Netscape.ReleaseDispatch();
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CApp object

CApp NEAR theApp;

// This identifier was generated to be statistically unique for your app.
// You may change it if you prefer to choose a specific identifier.
static const CLSID BASED_CODE clsid =
{ 0x18c692c8, 0x5d1d, 0x101c, { 0xb1, 0xd6, 0x0, 0x40, 0x95, 0x4, 0x30, 0x44 } };

/////////////////////////////////////////////////////////////////////////////
// CApp initialization
// Note for sample app:
// MFC apps check to see if they have been invoked by a user or automatically.
// Automatic invocations, such as by DDE or automation, leave the app invisible.
// An external viewer gets invoked via automation, but needs to be seen. See
// local variable Auto in the subroutine below.

// Note for sample app:
// We do CreateDispatch here to connect to the Netscape.Network.1 automation
// object.

// Note for sample app:
// The RegisterViewer method returns an error if the application has registered
// itself already. This is documented, although it doesn't make a lot of
// sense. We accommodate this by ignoring the return from RegisterViewer.
BOOL CApp::InitInstance()
{
	// Initialize OLE 2.0 libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	SetDialogBkColor();        // Set dialog background color to gray
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_NETTYPE,
		RUNTIME_CLASS(CDoc),
		RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
		RUNTIME_CLASS(CRunVw));
	AddDocTemplate(pDocTemplate);

	// Connect the COleTemplateServer to the document template.
	//  The COleTemplateServer creates new documents on behalf
	//  of requesting OLE containers by using information
	//  specified in the document template.
	m_server.ConnectTemplate(clsid, pDocTemplate, FALSE);

	// Register all OLE server factories as running.  This enables the
	//  OLE 2.0 libraries to create objects from other applications.
	COleTemplateServer::RegisterAll();
		// Note: MDI applications register all server objects without regard
		//  to the /Embedding or /Automation on the command line.

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// enable file manager drag/drop and DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes();

	// Parse the command line to see if launched as OLE server
	BOOL Auto = RunEmbedded() || RunAutomated();

	// When a server application is launched stand-alone, it is a good idea
	//  to update the system registry in case it has been damaged.
	m_server.UpdateRegistry(OAT_DISPATCH_OBJECT);
	COleObjectFactory::UpdateRegistryAll();

	// create the netscape object that we'll drive through OLE automation
	COleException e;
	if (!Auto) {
		IOleRegistry Registry;
		if (!Registry.CreateDispatch("Netscape.Registry.1", &e)) {
			AfxMessageBox("Could not connect to Netscape registry");
			AfxThrowUserException();
		}
		if (!Registry.RegisterViewer("image/x-portable-anymap", "NetAlive.Document.1")) {
			//AfxMessageBox("Could not register Net Alive! with Netscape");
			//AfxThrowUserException();
		}
    }
    
	if (!Netscape.CreateDispatch("Netscape.Network.1", &e))
	{
		AfxMessageBox("Could not connect to Netscape");
		AfxThrowUserException();
	}

	// simple command line parsing
	if (Auto) ;
	else if (m_lpCmdLine[0] == '\0')
	{
		// create a new (empty) document
		//OnFileNew();
	}
	else
	{
		// open an existing document
		OpenDocumentFile(m_lpCmdLine);
	}

	m_pMainWnd->DragAcceptFiles();
	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	ID_FILE_NEW,
	ID_FILE_OPEN,
	ID_FILE_SAVE,
		ID_SEPARATOR,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
		ID_SEPARATOR,
	ID_FILE_PRINT,
	ID_APP_ABOUT,
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE("Failed to create status bar\n");
		return -1;      // fail to create
	}

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRunVw

IMPLEMENT_DYNCREATE(CRunVw, CEditView)

BEGIN_MESSAGE_MAP(CRunVw, CEditView)
	//{{AFX_MSG_MAP(CRunVw)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRunVw construction/destruction

CRunVw::CRunVw()
{
	// TODO: add construction code here
}

CRunVw::~CRunVw()
{
}

/////////////////////////////////////////////////////////////////////////////
// CRunVw drawing

// Note for sample app:
// The sample app displays the incoming data in a Windows' Edit Control.
// CEditView supports this pretty well. We just have to do a SetWindowText
// everytime the data changes.
void CRunVw::OnDraw(CDC* pDC)
{
	CDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

BOOL CRunVw::PreCreateWindow(CREATESTRUCT &cs) {
	cs.style = 	AFX_WS_DEFAULT_VIEW |
	WS_VSCROLL |
	ES_AUTOVSCROLL |
	ES_MULTILINE | ES_NOHIDESEL | ES_READONLY;
	return CEditView::PreCreateWindow(cs);
}

void CRunVw::OnInitialUpdate() {
	CDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	SetWindowText(pDoc->data);
}

/////////////////////////////////////////////////////////////////////////////
// CRunVw diagnostics

#ifdef _DEBUG
void CRunVw::AssertValid() const
{
	CEditView::AssertValid();
}

void CRunVw::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CDoc* CRunVw::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDoc)));
	return (CDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDoc

IMPLEMENT_DYNCREATE(CDoc, CDocument)

BEGIN_MESSAGE_MAP(CDoc, CDocument)
	//{{AFX_MSG_MAP(CDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CDoc, CDocument)
	//{{AFX_DISPATCH_MAP(CDoc)
	DISP_FUNCTION(CDoc, "Close", Close, VT_EMPTY, VTS_I2)
	DISP_FUNCTION(CDoc, "Initialize", Initialize, VT_I2, VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CDoc, "Ready", Ready, VT_I4, VTS_NONE)
	DISP_FUNCTION(CDoc, "Write", Write, VT_EMPTY, VTS_PBSTR VTS_I4)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDoc construction/destruction

CDoc::CDoc()
{
	EnableAutomation();

	// TODO: add one-time construction code here

	AfxOleLockApp();
}

CDoc::~CDoc()
{
	AfxOleUnlockApp();
}

BOOL CDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CDoc serialization

void CDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar.Write(data, data.GetLength());
	}
	else
	{
		UINT got;
		char buffer[2048];
		do {
			got = ar.Read(buffer, sizeof buffer);
			data += CString(buffer, got);
		} while (got == sizeof buffer);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDoc diagnostics

#ifdef _DEBUG
void CDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDoc commands

// Note for sample app:
// Automation documents will be invisible by default and get closed
// when the automation server disconnects. This is not desirable.

// When Netscape finishes loading the document, it calls
// Close. The sample app then changes the document so it appears to MFC
// as though the user opened it manually. This involves calling ActivateFrame,
// which creates the MDI child window. ExternalDisconnect means that
// disconnection of the automation client will not close the window. For
// some reason, the document's ModifiedFlag gets set during the loading
// process. SetMofifiedFlag(FALSE) resets this. This prevents MFC saying
// "save changes to document" when closing the document.
void CDoc::Close(short iStatus) {
	POSITION p = GetFirstViewPosition();// connect to GUI
	CView *v = GetNextView(p);
	v->GetParentFrame()->ActivateFrame(SW_SHOWNORMAL);
	ExternalDisconnect();               // disconnect from OLE
	SetModifiedFlag(FALSE);             // clean at this point
}

// Note for sample app:
// We put the URL on the title bar.
short CDoc::Initialize(LPCSTR pMimeType, LPCSTR pUrl) {
	SetTitle(pUrl);
	return 1;
}

// Note for sample app:
// The sample app uses a CString to hold the document. CStrings
// have a capacity of 32767 bytes (due to 16 bit integers).
long CDoc::Ready() {
	return 32767 - data.GetLength();
}

void CDoc::Write(BSTR FAR* pData, long lBytes) {
	int l = lBytes < 32767 ? (int)lBytes : 32767;
	data += CString(*pData, l);
	for (POSITION p = GetFirstViewPosition(); p != NULL; ) {
		CView *v = GetNextView(p);
		v->SetWindowText(data);
	}
}
